"use strict";
/**
 * @athenna/artisan
 *
 * (c) João Lenon <lenon@athenna.io>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Serve = void 0;
const nodemon_1 = __importDefault(require("nodemon"));
const utils_1 = require("@secjs/utils");
const artisan_1 = require("@athenna/artisan");
class Serve extends artisan_1.Command {
    constructor() {
        super(...arguments);
        /**
         * The name and signature of the console command.
         */
        this.signature = 'serve';
        /**
         * The console command description.
         */
        this.description = 'Serve the Athenna application.';
    }
    /**
     * Set additional flags in the commander instance.
     * This method is executed when registering your command.
     *
     * @return {void}
     */
    addFlags(commander) {
        return commander.option('-w, --watch', 'Watch for file changes and re-start the HTTP server on change', false);
    }
    /**
     * Execute the console command.
     *
     * @return {Promise<void>}
     */
    async handle(options) {
        process.env.BOOT_LOGS = 'true';
        await artisan_1.Artisan.call('build');
        if (options.watch) {
            const ignorePaths = `--ignore ${utils_1.Path.tests()} ${utils_1.Path.storage()} ${utils_1.Path.pwd('node_modules')}`;
            nodemon_1.default(`--quiet ${ignorePaths} --watch ${utils_1.Path.pwd()} --exec 'node ${utils_1.Path.pwd('dist/bootstrap/main.js')}' -e ts`);
            return;
        }
        await Promise.resolve().then(() => __importStar(require(utils_1.Path.pwd('dist/bootstrap/main.js'))));
    }
}
exports.Serve = Serve;
